## die-engine 3.09

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(DetectItEasy)

if(WIN32)
    set (CMAKE_PREFIX_PATH "C:/Qt/5.15.2/msvc2019/")
endif()

if(APPLE)
    set (CMAKE_PREFIX_PATH $ENV{HOME}/Qt/5.15.2/clang_64/)
    set (CMAKE_OSX_ARCHITECTURES x86_64)
    add_compile_options(-Wno-deprecated-declarations)
    add_compile_options(-Wno-switch)
endif()

add_subdirectory(XCppfilt)
add_subdirectory(XCapstone)
add_subdirectory(XCapstone/x86)
add_subdirectory(XArchive)
add_subdirectory(XYara)
add_subdirectory(gui_source)
add_subdirectory(console_source)
add_subdirectory(lite_source)

include(GNUInstallDirs)

if(WIN32)
    install (TARGETS die)
    install (TARGETS diec)
    install (TARGETS diel)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    install (TARGETS die LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install (TARGETS diec LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install (TARGETS diel LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install (FILES LINUX/die.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications/)
    install (DIRECTORY LINUX/hicolor DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons)
    install (DIRECTORY XStyles/qss DESTINATION ${CMAKE_INSTALL_LIBDIR}/die)
    install (DIRECTORY XInfoDB/info DESTINATION ${CMAKE_INSTALL_LIBDIR}/die)
    install (DIRECTORY Detect-It-Easy/db DESTINATION ${CMAKE_INSTALL_LIBDIR}/die)
    install (DIRECTORY XYara/yara_rules DESTINATION ${CMAKE_INSTALL_LIBDIR}/die)
    install (DIRECTORY images DESTINATION ${CMAKE_INSTALL_LIBDIR}/die)
endif()

=== XArchive/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(XArchive)

add_subdirectory(${PROJECT_SOURCE_DIR}/3rdparty/bzip2)
add_subdirectory(${PROJECT_SOURCE_DIR}/3rdparty/lzma)
add_subdirectory(${PROJECT_SOURCE_DIR}/3rdparty/zlib)

=== XCapstone/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(capstone LANGUAGES C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

message(${PROJECT_SOURCE_DIR})

if(WIN32)
  add_definitions(-DWIN32)
endif()

add_definitions(
    -DCAPSTONE_HAS_ARM
    -DCAPSTONE_HAS_ARM64
    -DCAPSTONE_HAS_BPF
    -DCAPSTONE_HAS_EVM
    -DCAPSTONE_HAS_M68K
    -DCAPSTONE_HAS_M680X
    -DCAPSTONE_HAS_MIPS
    -DCAPSTONE_HAS_MOS65XX
    -DCAPSTONE_HAS_POWERPC
    -DCAPSTONE_HAS_RISCV
    -DCAPSTONE_HAS_SPARC
    -DCAPSTONE_HAS_SYSZ
    -DCAPSTONE_HAS_TMS320C64X
    -DCAPSTONE_HAS_WASM
    -DCAPSTONE_HAS_X86
    -DCAPSTONE_HAS_XCORE
    -DCAPSTONE_X86_ATT_DISABLE_NO
    -DCAPSTONE_DIET_NO
    -DCAPSTONE_X86_REDUCE_NO
    -DCAPSTONE_USE_SYS_DYN_MEM
    -D_LIB
    )
    
include_directories(${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/include)

add_library(capstone STATIC
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/MCInst.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/MCInstrDesc.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/MCRegisterInfo.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/SStream.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/AArch64/AArch64BaseInfo.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/AArch64/AArch64Disassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/AArch64/AArch64InstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/AArch64/AArch64Mapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/AArch64/AArch64Module.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/ARM/ARMDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/ARM/ARMInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/ARM/ARMMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/ARM/ARMModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/BPF/BPFDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/BPF/BPFInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/BPF/BPFMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/BPF/BPFModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/EVM/EVMDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/EVM/EVMInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/EVM/EVMMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/EVM/EVMModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/M680X/M680XDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/M680X/M680XInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/M680X/M680XModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/M68K/M68KDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/M68K/M68KInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/M68K/M68KModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/MOS65XX/MOS65XXDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/MOS65XX/MOS65XXModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Mips/MipsDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Mips/MipsInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Mips/MipsMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Mips/MipsModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/PowerPC/PPCDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/PowerPC/PPCInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/PowerPC/PPCMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/PowerPC/PPCModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/RISCV/RISCVDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/RISCV/RISCVInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/RISCV/RISCVMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/RISCV/RISCVModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Sparc/SparcDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Sparc/SparcInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Sparc/SparcMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/Sparc/SparcModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/SystemZ/SystemZDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/SystemZ/SystemZInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/SystemZ/SystemZMCTargetDesc.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/SystemZ/SystemZMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/SystemZ/SystemZModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/TMS320C64x/TMS320C64xDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/TMS320C64x/TMS320C64xInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/TMS320C64x/TMS320C64xMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/TMS320C64x/TMS320C64xModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/WASM/WASMDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/WASM/WASMInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/WASM/WASMMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/WASM/WASMModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86ATTInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86Disassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86DisassemblerDecoder.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86InstPrinterCommon.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86IntelInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86Mapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/X86/X86Module.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/XCore/XCoreDisassembler.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/XCore/XCoreInstPrinter.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/XCore/XCoreMapping.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/arch/XCore/XCoreModule.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/cs.c
    ${PROJECT_SOURCE_DIR}/3rdparty/Capstone/src/utils.c
)

set_target_properties(capstone PROPERTIES LINKER_LANGUAGE C)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

=== XCppfilt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(cppfilt LANGUAGES C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

message(${PROJECT_SOURCE_DIR})

add_definitions(
    -DHAVE_STDLIB_H
    -DHAVE_STRING_H
    )

include_directories(${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/)

add_library(cppfilt STATIC
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/cp-demangle.c 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/cplus-dem.c 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/d-demangle.c
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/rust-demangle.c 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/safe-ctype.c 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/xexit.c 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/xmalloc.c 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/xstrdup.c
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/ansidecl.h 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/cp-demangle.h 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/demangle.h 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/environ.h 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/libiberty.h 
${PROJECT_SOURCE_DIR}/3rdparty/cppfilt/src/safe-ctype.h
)

set_target_properties(cppfilt PROPERTIES LINKER_LANGUAGE C)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

=== XYara/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(XYara)

add_subdirectory(${PROJECT_SOURCE_DIR}/3rdparty/yara)

=== console_source/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(diec VERSION 3.09 LANGUAGES CXX)

include_guard(DIRECTORY)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

file(MAKE_DIRECTORY ../release)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ../release)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ../release)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ../release)

find_package(QT NAMES Qt5 COMPONENTS Core REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS Script REQUIRED)

add_definitions(-DUSE_DEX)
add_definitions(-DUSE_PDF)
add_definitions(-DUSE_ARCHIVE)

include(${PROJECT_SOURCE_DIR}/../die_script/die_script.cmake)
include(${PROJECT_SOURCE_DIR}/../XOptions/xoptions.cmake)
include(${PROJECT_SOURCE_DIR}/../XEntropyWidget/entropyprocess.cmake)
include(${PROJECT_SOURCE_DIR}/../XFileInfo/xfileinfo.cmake)

set(PROJECT_SOURCES
            ${DIE_SCRIPT_SOURCES}
            ${XOPTIONS_SOURCES}
            ${ENTROPYPROCESS_SOURCES}
            ${XFILEINFO_SOURCES}
            main_console.cpp
            consoleoutput.cpp
)

if(APPLE)
    add_library(${PROJECT_NAME} MODULE ${PROJECT_SOURCES})
    set_target_properties(${PROJECT_NAME} PROPERTIES
            MACOSX_BUNDLE_GUI_IDENTIFIER ntinfo.die
            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            BUNDLE TRUE)
    set(MACOSX_BUNDLE_ICON_FILE ../icons/main.icns)
else()
    add_executable(${PROJECT_NAME}
        ${PROJECT_SOURCES}
    )
endif()

target_link_libraries(${PROJECT_NAME} bzip2)
target_link_libraries(${PROJECT_NAME} lzma)
target_link_libraries(${PROJECT_NAME} zlib)
target_link_libraries(${PROJECT_NAME} capstone_x86)

target_link_libraries(${PROJECT_NAME} Qt5::Core)
target_link_libraries(${PROJECT_NAME} Qt5::Concurrent)
target_link_libraries(${PROJECT_NAME} Qt5::Script)

if(WIN32)
    target_link_libraries(${PROJECT_NAME} Wintrust)
    target_link_libraries(${PROJECT_NAME} Crypt32)
endif()

=== gui_source/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(die VERSION 3.09 LANGUAGES CXX)

include_guard(DIRECTORY)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

file(MAKE_DIRECTORY ../release)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ../release)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ../release)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ../release)

find_package(QT NAMES Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS OpenGL REQUIRED)
find_package(Qt5 COMPONENTS PrintSupport REQUIRED)
find_package(Qt5 COMPONENTS Svg REQUIRED)
find_package(Qt5 COMPONENTS Sql REQUIRED)
find_package(Qt5 COMPONENTS Network REQUIRED)
find_package(Qt5 COMPONENTS Script REQUIRED)
find_package(Qt5 COMPONENTS ScriptTools REQUIRED)

option(WITH_YARA "Use Yara" ON)

add_definitions(-DUSE_DEX)
add_definitions(-DUSE_PDF)
add_definitions(-DUSE_ARCHIVE)

if(WITH_YARA)
  add_definitions(-DUSE_YARA)
endif()

include(${PROJECT_SOURCE_DIR}/../XMIMEWidget/xmimewidget.cmake)
include(${PROJECT_SOURCE_DIR}/../FormatWidgets/formatwidgets.cmake)
include(${PROJECT_SOURCE_DIR}/../XSingleApplication/xsingleapplication.cmake)
include(${PROJECT_SOURCE_DIR}/../XAboutWidget/xaboutwidget.cmake)

set(PROJECT_SOURCES
            ${XMIMEWIDGET_SOURCES}
            ${FORMATWIDGETS_SOURCES}
            ${XSINGLEAPPLICATION_SOURCES}
            ${XABOUTWIDGET_SOURCES}
            dialogabout.cpp
            dialogabout.ui
            dialogoptions.cpp
            dialogoptions.ui
            dialogselectstyle.cpp
            dialogselectstyle.ui
            guimainwindow.cpp
            guimainwindow.ui
            main_gui.cpp
            res.qrc
)

if(APPLE)
    add_library(${PROJECT_NAME} MODULE ${PROJECT_SOURCES})
    set_target_properties(${PROJECT_NAME} PROPERTIES
            MACOSX_BUNDLE_GUI_IDENTIFIER ntinfo.die
            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            BUNDLE TRUE)
    set(MACOSX_BUNDLE_ICON_FILE ../icons/main.icns)
else()
    add_executable(${PROJECT_NAME} WIN32
        ${PROJECT_SOURCES}
    )
endif()

target_link_libraries(${PROJECT_NAME} bzip2)
target_link_libraries(${PROJECT_NAME} lzma)
target_link_libraries(${PROJECT_NAME} zlib)
target_link_libraries(${PROJECT_NAME} capstone)
target_link_libraries(${PROJECT_NAME} cppfilt)

if(WITH_YARA)
  target_link_libraries(${PROJECT_NAME} yara)
endif()

target_link_libraries(${PROJECT_NAME} Qt5::Widgets)
target_link_libraries(${PROJECT_NAME} Qt5::Concurrent)
target_link_libraries(${PROJECT_NAME} Qt5::OpenGL)
target_link_libraries(${PROJECT_NAME} Qt5::PrintSupport)
target_link_libraries(${PROJECT_NAME} Qt5::Svg)
target_link_libraries(${PROJECT_NAME} Qt5::Sql)
target_link_libraries(${PROJECT_NAME} Qt5::Network)
target_link_libraries(${PROJECT_NAME} Qt5::Script)
target_link_libraries(${PROJECT_NAME} Qt5::ScriptTools)

if(WIN32)
    target_link_libraries(${PROJECT_NAME} Wintrust)
    target_link_libraries(${PROJECT_NAME} Crypt32)
endif()

=== lite_source/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(diel VERSION 3.09 LANGUAGES CXX)

include_guard(DIRECTORY)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

file(MAKE_DIRECTORY ../release)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ../release)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ../release)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ../release)

find_package(QT NAMES Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Widgets REQUIRED)
find_package(Qt5 COMPONENTS Concurrent REQUIRED)
find_package(Qt5 COMPONENTS Script REQUIRED)

add_definitions(-DUSE_DEX)
add_definitions(-DUSE_PDF)
add_definitions(-DUSE_ARCHIVE)

include(${PROJECT_SOURCE_DIR}/../die_script/die_script.cmake)
include(${PROJECT_SOURCE_DIR}/../XOptions/xoptions.cmake)

set(PROJECT_SOURCES
            ${DIE_SCRIPT_SOURCES}
            ${XOPTIONS_SOURCES}
            main_lite.cpp
            litemainwindow.cpp
            litemainwindow.ui
)

if(APPLE)
    add_library(${PROJECT_NAME} MODULE ${PROJECT_SOURCES})
    set_target_properties(${PROJECT_NAME} PROPERTIES
            MACOSX_BUNDLE_GUI_IDENTIFIER ntinfo.die
            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            BUNDLE TRUE)
    set(MACOSX_BUNDLE_ICON_FILE ../icons/main.icns)
else()
    add_executable(${PROJECT_NAME} WIN32
        ${PROJECT_SOURCES}
    )
endif()

target_link_libraries(${PROJECT_NAME} bzip2)
target_link_libraries(${PROJECT_NAME} lzma)
target_link_libraries(${PROJECT_NAME} zlib)
target_link_libraries(${PROJECT_NAME} capstone_x86)

target_link_libraries(${PROJECT_NAME} Qt5::Widgets)
target_link_libraries(${PROJECT_NAME} Qt5::Concurrent)
target_link_libraries(${PROJECT_NAME} Qt5::Script)

if(WIN32)
    target_link_libraries(${PROJECT_NAME} Wintrust)
    target_link_libraries(${PROJECT_NAME} Crypt32)
endif()

=== XCapstone/x86/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(capstone_x86 LANGUAGES C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

message(${PROJECT_SOURCE_DIR})

if(WIN32)
  add_definitions(-DWIN32)
endif()

add_definitions(
    -DCAPSTONE_HAS_X86
    -DCAPSTONE_X86_ATT_DISABLE
    -DCAPSTONE_X86_REDUCE
    -DCAPSTONE_DIET_NO
    -DCAPSTONE_USE_SYS_DYN_MEM
    -D_LIB
    )
    
include_directories(${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/include)

add_library(capstone_x86 STATIC
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/MCInst.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/MCInstrDesc.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/MCRegisterInfo.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/SStream.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/arch/X86/X86Disassembler.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/arch/X86/X86DisassemblerDecoder.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/arch/X86/X86IntelInstPrinter.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/arch/X86/X86Mapping.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/arch/X86/X86Module.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/cs.c
    ${PROJECT_SOURCE_DIR}/../3rdparty/Capstone/src/utils.c
)

set_target_properties(capstone_x86 PROPERTIES LINKER_LANGUAGE C)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

=== XArchive/3rdparty/bzip2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(bzip2 LANGUAGES C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(${PROJECT_SOURCE_DIR}/src/)

add_library(bzip2 STATIC
${PROJECT_SOURCE_DIR}/src/bzip2.c
${PROJECT_SOURCE_DIR}/src/crctable.c
${PROJECT_SOURCE_DIR}/src/bzlib.c
${PROJECT_SOURCE_DIR}/src/compress.c
${PROJECT_SOURCE_DIR}/src/decompress.c
${PROJECT_SOURCE_DIR}/src/blocksort.c
${PROJECT_SOURCE_DIR}/src/randtable.c
${PROJECT_SOURCE_DIR}/src/huffman.c
)

set_target_properties(bzip2 PROPERTIES LINKER_LANGUAGE C)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

=== XArchive/3rdparty/lzma/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(lzma LANGUAGES C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(${PROJECT_SOURCE_DIR}/src/)

add_library(lzma STATIC
${PROJECT_SOURCE_DIR}/src/LzmaDec.c
${PROJECT_SOURCE_DIR}/src/Ppmd7.c
${PROJECT_SOURCE_DIR}/src/Ppmd7Dec.c
)

set_target_properties(lzma PROPERTIES LINKER_LANGUAGE C)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

=== XArchive/3rdparty/zlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(zlib LANGUAGES C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(${PROJECT_SOURCE_DIR}/src/)

add_library(zlib STATIC
${PROJECT_SOURCE_DIR}/src/deflate.c
${PROJECT_SOURCE_DIR}/src/inflate.c
${PROJECT_SOURCE_DIR}/src/adler32.c
${PROJECT_SOURCE_DIR}/src/crc32.c
${PROJECT_SOURCE_DIR}/src/inffast.c
${PROJECT_SOURCE_DIR}/src/inftrees.c
${PROJECT_SOURCE_DIR}/src/trees.c
${PROJECT_SOURCE_DIR}/src/zutil.c
)

set_target_properties(zlib PROPERTIES LINKER_LANGUAGE C)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

=== debian/changelog ===
die-engine (3.09-1parrot1) stable; urgency=medium

  * Fix lintian error
  * Add libc6 to Depends
  * Replace libc by ${misc:Depends}
  * Remove trailing space
  * Try moving info stuff to /usr/share/doc
  * Try enable Debian hardening build
  * Try building with cmake
  * New upstream version 3.09

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sat, 30 Dec 2023 11:40:08 +0700

die-engine (3.08-0parrot3) stable; urgency=medium

  * Use online CI URL instead

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 28 Nov 2023 19:05:44 +0700

die-engine (3.08-0parrot2) parrot-updates; urgency=medium

  * Update changelog for 3.08-0parrot1 release
  * Add CI script

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Fri, 27 Oct 2023 07:17:44 +0700

die-engine (3.08-0parrot1) parrot-updates; urgency=medium

  * New upstream version 3.08

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Fri, 27 Oct 2023 07:17:32 +0700

die-engine (3.07-0parrot2) parrot-updates; urgency=medium

  * Change new installation path of info

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sat, 04 Feb 2023 17:32:27 +0700

die-engine (3.07-0parrot1) parrot-updates; urgency=medium

  * New upstream version 3.07

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Fri, 03 Feb 2023 23:23:03 +0700

die-engine (3.06-0parrot1) parrot-updates; urgency=medium

  * New upstream version 3.06

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Mon, 05 Sep 2022 21:01:35 +0700

die-engine (3.05-0parrot1) parrot-updates; urgency=medium

  * New upstream version 3.05

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 09 Aug 2022 03:21:07 +0700

die-engine (3.04-0parrot1) parrot-updates; urgency=medium

  * New upstream version 3.04

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 27 Mar 2022 22:49:33 +0700

die-engine (3.03-0parrot3) rolling; urgency=medium

  * Fix missing pkg-config in build-depends

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Fri, 17 Dec 2021 18:56:03 +0700

die-engine (3.03-0parrot2) rolling; urgency=medium

  * No longer use custom install file
  * Use new build commands for new version

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 14 Nov 2021 14:31:03 +0700

die-engine (3.03-0parrot1) rolling-testing; urgency=medium

  * New upstream version 3.03

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 14 Nov 2021 13:24:59 +0700

die-engine (3.01-0parrot4) rolling; urgency=medium

  * Fix wrong syntax in watch file

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 14 Nov 2021 13:21:56 +0700

die-engine (3.01-0parrot3) rolling; urgency=medium

  * Move launchers to parrot-menu
  * Add watch file for automation update

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 14 Nov 2021 13:20:03 +0700

die-engine (3.01-0parrot2) rolling-testing; urgency=medium

  * Fix template copyright

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Wed, 14 Apr 2021 11:12:57 +0700

die-engine (3.01-0parrot1) rolling-testing; urgency=medium

  * Add parrot-build script
  * Fix build depends and crash on cobuild
  * Fix depends for GUI of DIE
  * Add icon to installation
  * Add launchers to installer
  * Add runtime libs
  * Add descriptions
  * Binary from file instead of generate from script
  * Add new build script
  * Move build script to debian/helper-scripts

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Wed, 14 Apr 2021 10:59:58 +0700

die-engine (3.01-0parrot0) rolling-testing; urgency=medium

  * Create upstream package

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Wed, 14 Apr 2021 06:49:07 +0700

=== debian/control ===
Source: die-engine
Section: devel
Priority: optional
Maintainer: Nong Hoang Tu <dmknght@parrotsec.org>
Build-Depends:
 debhelper-compat (= 13),
 qtscript5-dev,
 qt5-qmake,
 bash (>=5.2.15),
 libqt5svg5-dev,
 libqt5opengl5-dev,
 qttools5-dev-tools,
 pkg-config,
 cmake
Standards-Version: 4.5.1
Homepage: https://horsicq.github.io/
Vcs-Browser: https://nest.parrotsec.org/packages/tools/die-engine
Vcs-Git: https://nest.parrotsec.org/packages/tools/die-engine.git
Rules-Requires-Root: no

Package: detect-it-easy
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libqt5core5a,
 libqt5svg5,
 libqt5gui5,
 libqt5widgets5,
 libqt5opengl5,
 libqt5dbus5,
 libqt5scripttools5,
 libqt5script5,
 libqt5network5,
 libicu67,
Description: A program for determining types of files.
 "DIE" - Detect-It-Easy, is a cross-platform application
 that determines the type of file, and then sequentially
 loads all the signatures, which lie in the corresponding
 folder. Currently the program defines the following types:
 - MSDOS executable files MS-DOS
 - PE executable files Windows
 - ELF executable files Linux
 - MACH executable files Mac OS
 - Binary all other files

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --sourcedirectory=.
override_dh_auto_configure:
	dh_auto_configure -- -Wformat -Wformat-security -Werror=format-security
override_dh_fixperms:
	find debian/ -type f -name *.sg -exec chmod 644 {} \;
	find debian/ -type f -name *.html -exec chmod 0644 {} \;
	find debian/ -type f -name die.desktop -exec rm {} \;
	dh_fixperms

override_dh_auto_install:
	dh_auto_install
	mv ./debian/detect-it-easy/usr/lib/x86_64-linux-gnu/die/ ./debian/detect-it-easy/usr/lib/

=== debian/watch ===
version=4

https://github.com/horsicq/DIE-engine/releases/ .*/die_sourcecode_(\d.*)\.tar\.gz
